/* We seem to need to __ashldi3 to support some 'long long' ops.
 * Since kernel code doesn't link with libgcc.a we provide it here.
 * This code is from gcc 2.8.0's libgcc2.c   -- PMM 02/1998
 */
typedef int SItype 		__attribute__ ((mode (SI)));
typedef unsigned int USItype 	__attribute__ ((mode (SI)));
typedef int DItype 		__attribute__ ((mode (DI)));
typedef int word_type		__attribute__ ((mode (__word__)));
/* we know we're bigendian so only need one version of DIstruct */
struct DIstruct {SItype high,low}; 
typedef union 
{
	struct DIstruct s;
	DItype ll;
} DIunion;
#define BITS_PER_UNIT 8


DItype __ashldi3 (DItype u, word_type b)
{
	DIunion w;
	word_type bm;
	DIunion uu;
	
	if (b == 0)
		return u;
		
	uu.ll = u;
	
	bm = (sizeof (SItype) * BITS_PER_UNIT) - b;
	if (bm <= 0)
	{
		w.s.low = 0;
		w.s.high = (USItype)uu.s.low << -bm;
	}
	else
	{
		USItype carries = (USItype)uu.s.low >> bm;
		w.s.low = (USItype)uu.s.low << b;
		w.s.high = ((USItype)uu.s.high << b) | carries;
	}
	
	return w.ll;
}

 