/* initial definitions for double precision floating point.
 * Anything in here must not depend on functions in op-*.h
 * sfp-machine.h is available, though.
 */

#if _FP_W_TYPE_SIZE < 32
#error "Here's a nickel, kid.  Go buy yourself a real computer."
#endif

#ifdef UNDEF
#if _FP_W_TYPE_SIZE < 64
const _FP_I_TYPE _FP_FRACTBITS_D = 2 * _FP_W_TYPE_SIZE;
#else
const _FP_I_TYPE _FP_FRACTBITS_D = _FP_W_TYPE_SIZE;
#endif

const _FP_I_TYPE _FP_FRACBITS_D = 53;
const _FP_I_TYPE _FP_FRACXBITS_D = _FP_FRACTBITS_D - _FP_FRACBITS_D;
const _FP_I_TYPE _FP_WFRACBITS_D = _FP_WORKBITS + _FP_FRACBITS_D;
const _FP_I_TYPE _FP_WFRACXBITS_D = _FP_FRACTBITS_D - _FP_WFRACBITS_D;
const _FP_I_TYPE _FP_EXPBITS_D = 11;
const _FP_I_TYPE _FP_EXPBIAS_D = 1023;
const _FP_I_TYPE _FP_EXPMAX_D = 2047;
const _FP_W_TYPE _FP_QNANBIT_D = (_FP_W_TYPE)1 << (_FP_FRACBITS_D-2) % _FP_W_TYPE_SIZE;
const _FP_W_TYPE _FP_IMPLBIT_D = (_FP_W_TYPE)1 << (_FP_FRACBITS_D-1) % _FP_W_TYPE_SIZE;
const _FP_W_TYPE _FP_OVERFLOW_D = (_FP_W_TYPE)1 << _FP_WFRACBITS_D % _FP_W_TYPE_SIZE;
#else /* not UNDEF */

#if _FP_W_TYPE_SIZE < 64
#define _FP_FRACTBITS_D         (2 * _FP_W_TYPE_SIZE)
#else
#define _FP_FRACTBITS_D         _FP_W_TYPE_SIZE
#endif

#define _FP_FRACBITS_D          53
#define _FP_FRACXBITS_D         (_FP_FRACTBITS_D - _FP_FRACBITS_D)
#define _FP_WFRACBITS_D         (_FP_WORKBITS + _FP_FRACBITS_D)
#define _FP_WFRACXBITS_D        (_FP_FRACTBITS_D - _FP_WFRACBITS_D)
#define _FP_EXPBITS_D           11
#define _FP_EXPBIAS_D           1023
#define _FP_EXPMAX_D            2047

#define _FP_QNANBIT_D           \
        ((_FP_W_TYPE)1 << (_FP_FRACBITS_D-2) % _FP_W_TYPE_SIZE)
#define _FP_IMPLBIT_D           \
        ((_FP_W_TYPE)1 << (_FP_FRACBITS_D-1) % _FP_W_TYPE_SIZE)
#define _FP_OVERFLOW_D          \
        ((_FP_W_TYPE)1 << _FP_WFRACBITS_D % _FP_W_TYPE_SIZE)

#endif /* not UNDEF */

#if _FP_W_TYPE_SIZE < 64

union _FP_UNION_D
{
  double flt;
  struct {
#if __BYTE_ORDER == __BIG_ENDIAN
    unsigned sign  : 1;
    unsigned exp   : _FP_EXPBITS_D;
    unsigned frac1 : _FP_FRACBITS_D - (_FP_IMPLBIT_D != 0) - _FP_W_TYPE_SIZE;
    unsigned frac0 : _FP_W_TYPE_SIZE;
#else
    unsigned frac0 : _FP_W_TYPE_SIZE;
    unsigned frac1 : _FP_FRACBITS_D - (_FP_IMPLBIT_D != 0) - _FP_W_TYPE_SIZE;
    unsigned exp   : _FP_EXPBITS_D;
    unsigned sign  : 1;
#endif
  } bits __attribute__((packed));
};

#define __FP_D_IS_2_WORDS
#define __FP_D_SIZE 2
#define __FP_D_TYPE _FP_2
#define __FP_D_TYPE_struct _FP_2_struct
#else /* not _FP_W_TYPE_SIZE < 64 */

union _FP_UNION_D
{
  double flt;
  struct {
#if __BYTE_ORDER == __BIG_ENDIAN
    unsigned sign : 1;
    unsigned exp  : _FP_EXPBITS_D;
    unsigned long frac : _FP_FRACBITS_D - (_FP_IMPLBIT_D != 0);
#else
    unsigned long frac : _FP_FRACBITS_D - (_FP_IMPLBIT_D != 0);
    unsigned exp  : _FP_EXPBITS_D;
    unsigned sign : 1;
#endif
  } bits __attribute__((packed));
};

#define __FP_D_IS_1_WORD
#define __FP_D_SIZE 1
#define __FP_D_TYPE _FP_1
#define __FP_D_TYPE_struct _FP_1_struct
#endif /* not _FP_W_TYPE_SIZE < 64 */
