#include "soft-fp.h"
#include "quad.h"

int FCMPEQ(void *rd, void *rs2, void *rs1)
{
	FP_DECL_Q(A); FP_DECL_Q(B);
	long ret;
	unsigned long *fsr = rd;

#ifdef DEBUG_MATHEMU
	printk("FCMPEQ\n");
#endif
	/* This is a little simpler than the SPARC64 version
	 * because there's only a single set of condition codes. 
	 */
	FP_UNPACK_Q(A, rs1);
	FP_UNPACK_Q(B, rs2);

 	ret = FP_CMP_Q(B, A, 3);  /* 3 is the retcode for 'unordered comparison' */
 	if (ret == -1)
 		ret = 2;

	*fsr &= ~0xc00;          /* clear old ccodes */ 
	*fsr |= (ret << 10);     /* and put in the new ones */
	return 1;
}
