/* This is the part of the _FP_n_struct that is common to all of them. It comes first. */
#define _FP_COMMON_DECL _FP_I_TYPE c; _FP_I_TYPE s; _FP_I_TYPE e

typedef struct
{
   _FP_COMMON_DECL;
} _FP_COMMON_STRUCT;

typedef _FP_COMMON_STRUCT* _FP_VAL;

/* This is a bit grotty. We use the _FP_COMMON_STRUCT to allow
 * us to get at the common parts in op-common-post.h. I could
 * have used a union, which I suppose would have been the Right
 * Thing, but this would mean that every FP variable used the 
 * same amount of storage as a 4-word, even if (as in sparc64)
 * only 1 and 2 word variants were used. We rely on the compiler
 * laying out the various _FP_* structs in the same way.
 */

/* to declare an FP value, declare a struct and use a pointer to it.
 * We get away with swallow semicolon because declarations are special
 * and can't be inside if() statements and things...
 */
#define _FP_DECL(type, X) type##_struct X##obj; type X = &X##obj

/*
 * Helper primitives.
 */

/* Count leading zeros in a word. __FP_CLZ_DEFINED allows us to
 * override this with an asm definition in sfp-machine.h 
 */

#ifndef __FP_CLZ_DEFINED
INLINE _FP_I_TYPE __FP_CLZ(_FP_W_TYPE x)
{
   _FP_I_TYPE r = _FP_W_TYPE_SIZE - 1;
#if _FP_W_TYPE_SIZE > 32
   if (x > 0xffffffff) r -= 32;
   if (x > 0xffffffff) x >>= 32;
#endif
   if (x > 0xffff) r -= 16;
   if (x > 0xffff) x >>= 16;
   if (x > 0xff) r -= 8;
   if (x > 0xff) x >>= 8;
   if (x & 0xf0) r -= 4;
   if (x & 0xf0) x >>= 4;
   if (x & 0xc) r -= 2;
   if (x & 0xc) x >>= 2;
   if (x & 0x2) r -= 1;
   return r;
}
#endif /* not __FP_CLZ_DEFINED */

/* this one is a helper primitive that may be used in 
 * some of the DIV_MEAT routines.
 */
#define _FP_DIV_HELP_imm(q, r, n, d)		\
  do {						\
    q = n / d, r = n % d;			\
  } while (0)
