/* quad-pre.h */
#if _FP_W_TYPE_SIZE < 32
/* It appears to be traditional to abuse 16bitters in these header files... */
#error "Here's a nickel, kid. Go buy yourself a real computer."
#endif

#ifdef UNDEF

#if _FP_W_TYPE_SIZE < 64
const _FP_I_TYPE _FP_FRACTBITS_Q = 4 * _FP_W_TYPE_SIZE;
#else
const _FP_I_TYPE _FP_FRACTBITS_Q = 2 * _FP_W_TYPE_SIZE;
#endif

const _FP_I_TYPE _FP_FRACBITS_Q = 113;
const _FP_I_TYPE _FP_FRACXBITS_Q = _FP_FRACTBITS_Q - _FP_FRACBITS_Q;
const _FP_I_TYPE _FP_WFRACBITS_Q  = _FP_WORKBITS + _FP_FRACBITS_Q;
const _FP_I_TYPE _FP_WFRACXBITS_Q = _FP_FRACTBITS_Q - _FP_WFRACBITS_Q;
const _FP_I_TYPE _FP_EXPBITS_Q = 15;
const _FP_I_TYPE _FP_EXPBIAS_Q = 16383;
const _FP_I_TYPE _FP_EXPMAX_Q = 32767;
const _FP_W_TYPE _FP_QNANBIT_Q = (_FP_W_TYPE)1 << (_FP_FRACBITS_Q-2) % _FP_W_TYPE_SIZE;
const _FP_W_TYPE _FP_IMPLBIT_Q = (_FP_W_TYPE)1 << (_FP_FRACBITS_Q-1) % _FP_W_TYPE_SIZE;
const _FP_W_TYPE _FP_OVERFLOW_Q = (_FP_W_TYPE)1 << _FP_WFRACBITS_Q % _FP_W_TYPE_SIZE;

#else /* not UNDEF */
#if _FP_W_TYPE_SIZE < 64
#define _FP_FRACTBITS_Q         (4*_FP_W_TYPE_SIZE)
#else
#define _FP_FRACTBITS_Q         (2*_FP_W_TYPE_SIZE)
#endif

#define _FP_FRACBITS_Q          113
#define _FP_FRACXBITS_Q         (_FP_FRACTBITS_Q - _FP_FRACBITS_Q)
#define _FP_WFRACBITS_Q         (_FP_WORKBITS + _FP_FRACBITS_Q)
#define _FP_WFRACXBITS_Q        (_FP_FRACTBITS_Q - _FP_WFRACBITS_Q)
#define _FP_EXPBITS_Q           15
#define _FP_EXPBIAS_Q           16383
#define _FP_EXPMAX_Q            32767

#define _FP_QNANBIT_Q           \
        ((_FP_W_TYPE)1 << (_FP_FRACBITS_Q-2) % _FP_W_TYPE_SIZE)
#define _FP_IMPLBIT_Q           \
        ((_FP_W_TYPE)1 << (_FP_FRACBITS_Q-1) % _FP_W_TYPE_SIZE)
#define _FP_OVERFLOW_Q          \
        ((_FP_W_TYPE)1 << (_FP_WFRACBITS_Q % _FP_W_TYPE_SIZE))

#endif

#if _FP_W_TYPE_SIZE < 64

union _FP_UNION_Q
{
   /* long double is actually only 64bits, not 128, but
    * it doesn't matter because we never try to convert by
    * assigning to foo->flt -- we always cast a void* to
    * the union type. 
    */
   long double flt;
   struct 
   {
#if __BYTE_ORDER == __BIG_ENDIAN
      unsigned sign : 1;
      unsigned exp : _FP_EXPBITS_Q;
      unsigned long frac3 : _FP_FRACBITS_Q - (_FP_IMPLBIT_Q != 0)-(_FP_W_TYPE_SIZE * 3);
      unsigned long frac2 : _FP_W_TYPE_SIZE;
      unsigned long frac1 : _FP_W_TYPE_SIZE;
      unsigned long frac0 : _FP_W_TYPE_SIZE;
#else
      unsigned long frac0 : _FP_W_TYPE_SIZE;
      unsigned long frac1 : _FP_W_TYPE_SIZE;
      unsigned long frac2 : _FP_W_TYPE_SIZE;
      unsigned long frac3 : _FP_FRACBITS_Q - (_FP_IMPLBIT_Q != 0)-(_FP_W_TYPE_SIZE * 3);
      unsigned exp : _FP_EXPBITS_Q;
      unsigned sign : 1;
#endif /* not bigendian */
   } bits __attribute__((packed));
};

#define __FP_Q_IS_4_WORDS
#define __FP_Q_SIZE 4
#define __FP_Q_TYPE _FP_4
#define __FP_Q_TYPE_struct _FP_4_struct
#else   /* not _FP_W_TYPE_SIZE < 64 */



union _FP_UNION_Q
{
  long double flt /* __attribute__((mode(TF))) */ ;
  struct {
#if __BYTE_ORDER == __BIG_ENDIAN
    unsigned sign  : 1;
    unsigned exp   : _FP_EXPBITS_Q;
    unsigned long frac1 : _FP_FRACBITS_Q-(_FP_IMPLBIT_Q != 0)-_FP_W_TYPE_SIZE;
    unsigned long frac0 : _FP_W_TYPE_SIZE;
#else
    unsigned long frac0 : _FP_W_TYPE_SIZE;
    unsigned long frac1 : _FP_FRACBITS_Q-(_FP_IMPLBIT_Q != 0)-_FP_W_TYPE_SIZE;
    unsigned exp   : _FP_EXPBITS_Q;
    unsigned sign  : 1;
#endif
  } bits;
};

#define __FP_Q_IS_2_WORDS
#define __FP_Q_SIZE 2
#define __FP_Q_TYPE _FP_2
#define __FP_Q_TYPE_struct _FP_4_struct
#endif /* not _FP_W_TYPE_SIZE < 64 */
